# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/sql/property/instance_name'
require 'google/sql/property/string'
require 'google/sql/property/time'
require 'puppet'

Puppet::Type.newtype(:gsql_ssl_cert) do
  @doc = <<-EOT
    Represents an SSL certificate created for a Cloud SQL instance. To use the
    SSL certificate you must have the SSL Client Certificate and the associated
    SSL Client Key. The Client Key can be downloaded only when the SSL
    certificate is created with the insert method.
  EOT

  autorequire(:gauth_credential) do
    [self[:credential]]
  end

  autorequire(:gsql_instance) do
    self[:instance].autorequires
  end

  newparam :credential do
    desc <<-EOT
      A gauth_credential name to be used to authenticate with Google Cloud
      Platform.
    EOT
  end

  newparam(:project) do
    desc 'A Google Cloud Platform project to manage.'
  end

  newparam(:instance, parent: Google::Sql::Property::InstancNameRef) do
    desc 'A reference to Instance resource'
  end

  newparam(:sha1_fingerprint, namevar: true,
                              parent: Google::Sql::Property::String) do
    desc 'The SHA-1 of the certificate.'
  end

  newproperty(:cert, parent: Google::Sql::Property::String) do
    desc 'PEM representation of the X.509 certificate.'
  end

  newproperty(:cert_serial_number, parent: Google::Sql::Property::String) do
    desc 'Serial number, as extracted from the certificate.'
  end

  newproperty(:common_name, parent: Google::Sql::Property::String) do
    desc 'User supplied name. Constrained to [a-zA-Z.-_ ]+.'
  end

  newproperty(:create_time, parent: Google::Sql::Property::Time) do
    desc <<-EOT
      The time when the certificate was created in RFC 3339 format, for example
      2012-11-15T16:19:00.094Z.
    EOT
  end

  newproperty(:expiration_time, parent: Google::Sql::Property::Time) do
    desc <<-EOT
      The time when the certificate expires in RFC 3339 format, for example
      2012-11-15T16:19:00.094Z.
    EOT
  end
end
